# NVIDIA Container Toolkit

[![GitHub license](https://img.shields.io/github/license/NVIDIA/nvidia-docker?style=flat-square)](https://raw.githubusercontent.com/NVIDIA/nvidia-docker/main/LICENSE)

**NOTE:** The `nvidia-docker2` package that is generated by this repository is a meta
package that only serves to introduce a dependency on `nvidia-container-toolkit`
package which includes all the components of the [NVIDIA Container Toolkit](https://github.com/NVIDIA/nvidia-container-toolkit).

The `nvidia-docker` wrapper script that was included in this repository is no
longer included in the package and a configuration specific to the target
container engine (e.g. Docker, Containerd, Cri-o, or Podman) is suggested
instead.

For Docker users specifically, the NVIDIA Container Toolkit CLI (`nvidia-ctk`)
includes functionality to ensure that the `nvidia` runtime has been registered
with the Docker daemon. Installing the NVIDIA Container Toolkit and running:
```
sudo nvidia-ctk runtime configure
```
will load (or create) an `/etc/docker/daemon.json` file and ensure that the
NVIDIA Container Runtime is configured as a runtime named `nvidia`.

Restarting the Docker daemon is required for this to take affect.

For further instructions, see the NVIDIA Container Toolkit [documentation](https://docs.nvidia.com/datacenter/cloud-native/container-toolkit)
and specifically the [user guide](https://docs.nvidia.com/datacenter/cloud-native/container-toolkit/user-guide.html).

## Issues and Contributing

[Checkout the Contributing document!](CONTRIBUTING.md)

* Please let us know by [filing a new issue](https://github.com/NVIDIA/nvidia-container-toolkit/issues/new) against the `nvidia-container-toolkit` repository.
* You can contribute by opening a [merge request](https://gitlab.com/nvidia/container-toolkit/container-toolkit/-/merge_requests)
